#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>

int main () {
  char command[255];
  char seps[] = " \t";
  char *part;
  char *args[10];
  short no_args;
  int background, status, pid, wpid;

  while (1) {
    // Beendete Kindprozesse einsammeln
    wpid = waitpid (WAIT_ANY, &status, WNOHANG);
    while ( wpid > 0) {
      printf ("Process %d terminated.\n", wpid); 
      wpid = waitpid (WAIT_ANY, &status, WNOHANG);
    };
  
    printf ("spsh$ ");
    fgets (command, sizeof(command), stdin);
    // Aus Eingabe \n abschneiden
    command[strlen(command)-1] = (char) 0;

    no_args = 0;
    background = 0;
    
    part = strtok (command, seps);
    while ( part != NULL ) {
      args[no_args] = part;
      no_args++;
      part = strtok (NULL, seps);
    };

    // Test, ob letztes Argument ein "&" ist -> background
    if (!strcmp(args[no_args-1],"&")) {
      no_args--;
      background = 1;
    };

    if (no_args == 0) continue;  // kein fork/exec

    // internes Kommando?
    if (!strcmp(args[0],"exit")) {
      printf ("Terminating\n");
      exit(0);
    };
    
    // Kommando mit exec ausfuehren
    args[no_args] = NULL;

    pid = fork();
    if ( pid == 0 ) {
      // Kindprozess
      execvp (args[0], args);
      // exec fehlgeschlagen?
      printf ("%s not found\n", args[0]);
      exit(0);
    } else {
      printf ("Process %d launched: ", pid);
      // Vaterprozess
      if (background == 0) {
        printf ("foreground\n");
        waitpid (pid, &status, 0);
      } else {
        printf ("background\n");
      };
      background = 0;
    };
  }
}

